`timescale 1ns / 1ns
`default_nettype none

//////////////////////////////////////////////////////////////////////////////////
// Company: 
// Engineer: 
// 
// Create Date:    16:55:26 06/21/2018 
// Design Name: 
// Module Name:    tld_zxuno 
// Project Name: 
// Target Devices: 
// Tool versions: 
// Description: 
//
// Dependencies: 
//
// Revision: 
// Revision 0.01 - File Created
// Additional Comments: 
//
//////////////////////////////////////////////////////////////////////////////////

module tld_CYC1000 (
  input wire clk50mhz,  // cristal de 50 MHz
  output wire Out_TMDS_D0,  // Salidas R,G,B TMDS
  output wire Out_TMDS_D1,  // de 8 bits
  output wire Out_TMDS_D2,  // cada una
  output wire Out_TMDS_CLK,
  
  
  
  
  
  
  output wire Out_TMDS_D0_N,//
  output wire Out_TMDS_D1_N,//negativa puesta a 0
  output wire Out_TMDS_D2_N,//
  output wire Out_TMDS_CLK_N
  );

  wire [7:0] r8b,g8b,b8b;
  wire clk125m;
  wire hsync;
  wire vsync;
  wire hblank;
  
 // assign r = r8b[7:2]; // como solo tenemos 6 bits por componente de color, asignamos de los 8 bits 
 // assign g = g8b[7:2]; // originales de cada color solo los 6 bits mas significativos 
 // assign b = b8b[7:2]; // (esto en ZX-UNO cambiaria a los 3 bits mas significativos)
	 
  wire clkvga;
  // cambiar el contenido de este modulo (reloj_cyclone) si hay que cambiar la frecuencia del reloj
  // si es que hemos cambiado el ModeLine en videosyncs.v para generar otra frecuencia distinta
  reloj_cyclone reloj (
	  .inclk0(clk50mhz),
	  .c0(clkvga),
	  .c1(clk125m)
	  );
    
  fantasma_rebotando el_ejemplo (
    .clk(clkvga),
    .r(r8b),
    .g(g8b),
    .b(b8b),
	 .hblank(hblank),
    .hsync(hsync),
    .vsync(vsync)
    );  

	hdmi
   //paso de ctes
//  #(25200000, 48000, 25200, 6144)
	
   hdmi_18bits
	
 (
	//clocks
	.CLK_DVI_I(clk125m),	 
	.CLK_PIXEL_I(clkvga),		
	
	// components
	.R_I(r8b),				
	.G_I(g8b),				
	.B_I(b8b),				
	.BLANK_I(~hblank),			
	.HSYNC_I(hsync),			
	.VSYNC_I(vsync),			
	
	// PCM audio 
	//.I_AUDIO_PCM_L(), 	
	//.I_AUDIO_PCM_R(),	
	
	// TMDS output
	.TMDS_D0_O(Out_TMDS_D0),		
	.TMDS_D1_O(Out_TMDS_D1),		
	.TMDS_D2_O(Out_TMDS_D2),		
	.TMDS_CLK_O(Out_TMDS_CLK));		
	
	
 // assign hblank = hsync && vsync;
 // assign Out_TMDS_D0_N  = 1'b0;//Es como desaparece el ruido definiendo pines y no asignándolos
  assign Out_TMDS_D1_N  = 1'b0; //negativa puesta a 0
 // assign Out_TMDS_D2_N  = 1'b0; //
 // assign Out_TMDS_CLK_N = 1'b0;
 
  
	 	 
endmodule

`default_nettype wire